//
// Created by 12567 on 2021/3/31.
//

#include <jni.h>
#include <syscall.h>
#include "wdun.h"
#include "cJSON.h"

//import asm symbol
IMPORTWDSYSCALL

#define WDMAIN_CLASS_NAME "com/reyun/wandun/WdMain"
#define WDMAIN_GETWDID_METHOD_NAME "getWdIdNative"
#define WDMAIN_GETWDID_METHOD_SIG "()Ljava/lang/String;"

jstring jni_get_wdid(JNIEnv* env, jobject thiz) {

}

JNIEXPORT jint JNI_OnLoad(JavaVM* vm, void* reserved) {
    int pid = WDSYSCALL(SYS_getpid);
    JNIEnv* env = NULL;
    if((*vm)->GetEnv(vm, (void**)&env, JNI_VERSION_1_6) == JNI_TRUE) {
        jclass cls = (*env)->FindClass(env, WDMAIN_CLASS_NAME);
        JNINativeMethod methods[] = {{WDMAIN_GETWDID_METHOD_NAME, WDMAIN_GETWDID_METHOD_SIG, (void*)jni_get_wdid}};
        (*env)->RegisterNatives(env, cls, methods, sizeof(methods)/sizeof(JNINativeMethod));
    }
    cJSON* json = cJSON_CreateObject();
    cJSON_AddStringToObject(json, "name", "zhanglei");
    char* json_str = cJSON_Print(json);
    cJSON_free(json);
    return JNI_VERSION_1_6;
}

